<?php
/*
Plugin Name: Minecraft Admin
Plugin URI: http://profenter.de/portal/gruppen/minecraft-admin-fur-wordpress/frontpage/
Description:“Minecraft Admin for Wordpress” is a plugin for Wordpress, you can configure and manage your Minecraft/Bukkit Server with your wordpress blog.
Version: 0.4.1.2
Author: Profenter Games
Author URI: http://profenter.de
*/
if (!function_exists('add_action')) {
  header('Status: 403 Forbidden');
  header('HTTP/1.1 403 Forbidden');
  exit();
} //!function_exists('add_action')
define('MINECRAFT_ADMIN_ADMIN_PAGE_NAME', 'minecraft-admin');
load_plugin_textdomain('minecraft-admin', dirname(plugin_basename(__FILE__)) . '/languages/', dirname(plugin_basename(__FILE__)) . '/languages/');
class minecraft_admin
{
  function minecraft_admin()
  {
    add_filter('screen_layout_columns', array(
      &$this,
      'on_screen_layout_columns'
    ), 10, 2);
    add_action('admin_menu', array(
      &$this,
      'on_admin_menu'
    ));
    add_action('admin_post_save_minecraft_admin_general', array(
      &$this,
      'on_save_changes'
    ));
    add_action('wp_before_admin_bar_render', array(
      &$this,
      'mc_nav'
    ));
    wp_register_style('filebrowser-style', get_bloginfo('wpurl') . '/wp-content/plugins/minecraft-admin/css/minecraft-admin-backend.css', array(), '20120208', 'all');
    wp_register_sidebar_widget('minecraft_admin_widget_1', __('Minecraft Server Status', 'minecraft-admin'), array(
      &$this,
      'widget_sidebar_status'
    ), array(
      'description' => __('Diese Widget zeigt an, ob dein Minecraft Server an oder aus ist.', 'minecraft-admin')
    ));
    wp_register_widget_control('minecraft_admin_widget_1', 'Minecraft Admin', array(
      &$this,
      'minecraft_admin_widget_1_einstellungen'
    ), array(
      'width' => 300
    ));
  }
  function minecraft_admin_widget_1_einstellungen()
  {
    $options = get_option('minecraft_admin_widget_1_einstellungen');
    if (!is_array($options)) {
      $options = array(
        'title' => 'Minecraft Server',
        'adresse' => '160px'
      );
    } //!is_array($options)
    if ($_POST['minecraft_admin_widget_1_einstellungen-submit']) {
      $options['title']   = strip_tags(stripslashes($_POST['minecraft_admin_widget_1_einstellungen-title']));
      $options['adresse'] = strip_tags(stripslashes($_POST['minecraft_admin_widget_1_einstellungen-adresse']));
      update_option('minecraft_admin_widget_1_einstellungen', $options);
    } //$_POST['minecraft_admin_widget_1_einstellungen-submit']
    echo '<p style="text-align:right;">
	<label for="minecraft_admin_widget_1_einstellungen-title">' . __("Titel", "minecraft-admin") . ':
	<input style="width: 200px;" id="minecraft_admin_widget_1_einstellungen-title" name="minecraft_admin_widget_1_einstellungen-title" type="text" value="' . htmlspecialchars($options['title'], ENT_QUOTES) . '" /></label>
	</p><p style="text-align:right;">
	<label for="minecraft_admin_widget_1_einstellungen-adresse">' . __("Adresse anzeigen", "minecraft-admin") . ':
	<input style="width: 200px;" id="minecraft_admin_widget_1_einstellungen-adresse" name="minecraft_admin_widget_1_einstellungen-adresse" type="checkbox" ' . (htmlspecialchars($options['adresse'], ENT_QUOTES) == "ja" ? "checked" : "") . ' value="ja" />
	</label></p><input type="hidden" id="minecraft_admin_widget_1_einstellungen-submit" name="minecraft_admin_widget_1_einstellungen-submit" value="1" />';
  }
  function mc_nav()
  {
    global $wp_admin_bar;
    $wp_admin_bar->add_menu(array(
      'id' => 'minecraft-admin',
      'title' => __('Minecraft Admin','minecraft-admin'),
      'href' => '/wp-admin/admin.php?page=minecraft-admin'
    ));
    $wp_admin_bar->add_menu(array(
      'id' => 'minecraft-admin-befehl',
      'parent' => 'minecraft-admin',
      'title' => __('Befehle','minecraft-admin'),
      'href' => '/wp-admin/admin.php?page=minecraft-admin?site=befehle'
    ));
    $wp_admin_bar->add_menu(array(
      'id' => 'minecraft-admin-befehl-start',
      'parent' => 'minecraft-admin-befehl',
      'title' => __('Starten','minecraft-admin'),
      'href' => '/wp-admin/admin.php?page=minecraft-admin?site=befehle&p=start'
    ));
    $wp_admin_bar->add_menu(array(
      'id' => 'minecraft-admin-befehl-stop',
      'parent' => 'minecraft-admin-befehl',
      'title' => __('Stoppen','minecraft-admin'),
      'href' => '/wp-admin/admin.php?page=minecraft-admin?site=befehle&p=stop'
    ));
    $wp_admin_bar->add_menu(array(
      'id' => 'minecraft-admin-befehl-restart',
      'parent' => 'minecraft-admin-befehl',
      'title' => __('Neustarten','minecraft-admin'),
      'href' => '/wp-admin/admin.php?page=minecraft-admin?site=befehle&p=restart'
    ));
    $wp_admin_bar->add_menu(array(
      'id' => 'minecraft-admin-server-properties',
      'parent' => 'minecraft-admin',
      'title' => __('InGame Einstellungen','minecraft-admin'),
      'href' => '/wp-admin/admin.php?page=minecraft-admin?site=server.properties'
    ));
    $wp_admin_bar->add_menu(array(
      'id' => 'minecraft-admin-cronjob',
      'parent' => 'minecraft-admin',
      'title' => __('Wiederkehrende Aktionen','minecraft-admin'),
      'href' => '/wp-admin/admin.php?page=minecraft-admin?site=cronjob'
    ));
    $wp_admin_bar->add_menu(array(
      'id' => 'minecraft-admin-einstellungen',
      'parent' => 'minecraft-admin',
      'title' => __('Einstellungen','minecraft-admin'),
      'href' => '/wp-admin/admin.php?page=minecraft-admin?site=einstellungen'
    ));
    $wp_admin_bar->add_menu(array(
      'id' => 'minecraft-admin-filebrowser',
      'parent' => 'minecraft-admin',
      'title' => __('Filebrowser','minecraft-admin'),
      'href' => '/wp-admin/admin.php?page=minecraft-admin?site=filebrowser'
    ));
  }
  function widget_sidebar_status($args)
  {
    extract($args);
    $op = get_option('minecraft_admin_widget_1_einstellungen');
    echo $before_widget . $before_title . $op["title"] . $after_title;
    $options = get_option('mc_settings_options');
    $output  = shell_exec('sh /etc/init.d/minecraft status');
    $output  = str_replace("craftbukkit.jar", "Minecraft", $output);
    echo '<a class="button" style="color:green;">' . $output . '</a><br />';
    $output = shell_exec('sh /etc/init.d/minecraft command "list"');
    $output = str_replace("craftbukkit.jar", "Minecraft", $output);
    $output = str_replace("[0m", "", $output);
    $output = str_replace("[m", "", $output);
    echo '<br /><b>' . __("Online Spieler:", "minecraft-admin") . '</b><br />' . $output;
    if ($op["adresse"] == "ja") {
      $properties = file($options['pfad'] . "server.properties");
      foreach ($properties as $key => $value) {
        $val = explode("=", $value);
        if ($val[0] == "server-ip") {
          $val[1] = (empty($val[1])) ? $_SERVER['HTTP_HOST'] : $val[1];
          echo '<br /><a class="button" style="color:green;position: absolute;">' . $val[1] . '</a><br /><br /><br />';
          break;
        } //$val[0] == "server-ip"
      } //$properties as $key => $value
    } //$op["adresse"] == "ja"
    echo $after_widget;
  }
  function on_screen_layout_columns($columns, $screen)
  {
    if (!defined('WP_NETWORK_ADMIN') && !defined('WP_USER_ADMIN')) {
      if ($screen == $this->pagehook) {
        $columns[$this->pagehook] = 2;
      } //$screen == $this->pagehook
    } //!defined('WP_NETWORK_ADMIN') && !defined('WP_USER_ADMIN')
    return $columns;
  }
  function on_admin_menu()
  {
    $this->pagehook = add_menu_page('Minecraft', 'Minecraft', "Subscriber", MINECRAFT_ADMIN_ADMIN_PAGE_NAME, array(
      &$this,
      'on_show_page'
    ));
    settings_fields('mc_settings');
    register_setting('mc_settings', 'mc_settings_options');
    $options = get_option('installiert');
    if ($options != "ja") {
      add_submenu_page(MINECRAFT_ADMIN_ADMIN_PAGE_NAME, __('Installieren', 'minecraft-admin'), __('Installieren', 'minecraft-admin'), "Subscriber", MINECRAFT_ADMIN_ADMIN_PAGE_NAME . '?site=installieren', array(
        &$this,
        'mc_install'
      ));
    } //$options != "ja"
    else {
      add_submenu_page(MINECRAFT_ADMIN_ADMIN_PAGE_NAME, __('Befehle', 'minecraft-admin'), __('Befehle', 'minecraft-admin'), "Subscriber", MINECRAFT_ADMIN_ADMIN_PAGE_NAME . '?site=befehle', array(
        &$this,
        'mc_start'
      ));
      add_submenu_page(MINECRAFT_ADMIN_ADMIN_PAGE_NAME, __('InGame Einstellungen - server.properties', 'minecraft-admin'), __('InGame Einstellungen', 'minecraft-admin'), "Subscriber", MINECRAFT_ADMIN_ADMIN_PAGE_NAME . '?site=server.properties', array(
        &$this,
        'mc_server_properties'
      ));
      add_submenu_page(MINECRAFT_ADMIN_ADMIN_PAGE_NAME, __('Wiederkehrende Aktionen', 'minecraft-admin'), __('Wiederkehrende Aktionen', 'minecraft-admin'), "Subscriber", MINECRAFT_ADMIN_ADMIN_PAGE_NAME . '?site=cronjob', array(
        &$this,
        'cronjob'
      ));
      add_submenu_page(MINECRAFT_ADMIN_ADMIN_PAGE_NAME, __('Einstellungen - Basic', 'minecraft-admin'), __('Einstellungen', 'minecraft-admin'), "Subscriber", MINECRAFT_ADMIN_ADMIN_PAGE_NAME . '?site=einstellungen', array(
        &$this,
        'mc_admin_do_page'
      ));
      add_submenu_page(MINECRAFT_ADMIN_ADMIN_PAGE_NAME, __('Filebrowser', 'minecraft-admin'), __('Filebrowser', 'minecraft-admin'), "Subscriber", MINECRAFT_ADMIN_ADMIN_PAGE_NAME . '?site=filebrowser', array(
        &$this,
        'filebrowser'
      ));
    }
    add_action('load-' . $this->pagehook, array(
      &$this,
      'on_load_page'
    ));
  }
  function on_load_page()
  {
    wp_enqueue_script('common');
    wp_enqueue_script('wp-lists');
    wp_enqueue_script('postbox');
    add_meta_box('mc_admin_eins', __("Logo", 'minecraft-admin'), array(
      &$this,
      'mc_admin_eins'
    ), $this->pagehook, 'side', 'core');
    add_meta_box('mc_admin_zwei', __("Debug-Infos", 'minecraft-admin'), array(
      &$this,
      'mc_admin_zwei'
    ), $this->pagehook, 'normal', 'core');
    add_meta_box('mc_admin_drei', __("Erstellt von", 'minecraft-admin'), array(
      &$this,
      'mc_admin_drei'
    ), $this->pagehook, 'normal', 'core');
    add_meta_box('mc_admin_vier', __("Links", 'minecraft-admin'), array(
      &$this,
      'mc_admin_vier'
    ), $this->pagehook, 'additional', 'core');
    add_meta_box('mc_admin_fuenf', __("Steuerung", 'minecraft-admin'), array(
      &$this,
      'mc_admin_fuenf'
    ), $this->pagehook, 'additional', 'core');
  }
  function on_show_page()
  {
    if ($_GET["site"] == "neuinstallieren") {
      update_option('installiert', "nein");
      echo '<meta http-equiv="refresh" content="0; URL=admin.php?page=minecraft-admin?site=installieren"> ';
    } //$_GET["site"] == "neuinstallieren"
    global $screen_layout_columns;
    echo '<div id="minecraft-admin-general" class="wrap">';
    screen_icon('options-general');
    echo '<h2>Minecraft Admin</h2><form action="admin-post.php" method="post">';
    wp_nonce_field('minecraft-admin-general');
    wp_nonce_field('closedpostboxes', 'closedpostboxesnonce', false);
    wp_nonce_field('meta-box-order', 'meta-box-order-nonce', false);
    echo '<input type="hidden" name="action" value="save_minecraft_admin_general" />';
    $data = array(
      'My Data 1',
      'My Data 2',
      'Available Data 1'
    );
    do_meta_boxes($this->pagehook, 'side', $data);
    do_meta_boxes($this->pagehook, 'normal', $data);
    do_meta_boxes($this->pagehook, 'additional', $data);
    echo '</form></div><script type="text/javascript">
		//<![CDATA[
		jQuery(document).ready( function($) {
			// close postboxes that should be closed
			$(".if-js-closed").removeClass("if-js-closed").addClass("closed");
			// postboxes setup
			postboxes.add_postbox_toggles("' . $this->pagehook . '");
		});
		//]]>
	</script>';
  }
  function on_save_changes()
  {
    check_admin_referer('minecraft-admin-general');
    wp_redirect($_POST['_wp_http_referer']);
  }
  function mc_admin_eins()
  {
    echo '<img src="http://profenter.de/wp-content/uploads/group-avatars/5/218cc8617b3663b88bf3be9cc931c3ad-bpfull.jpg" alt="Logo" />';
  }
  function mc_admin_zwei()
  {
    echo '<b>Server:</b> <br />' . php_uname() . '<br /><b>Client:</b><br />' . $_SERVER['HTTP_USER_AGENT'] . '<br/><b>Version:</b><br />0.3.2';
  }
  function mc_admin_drei()
  {
    echo __("Minecraft Admin für WordPress<br /> wurde erstellt von ", 'minecraft-admin') . '<br /><img src="http://profenter.de/wp-content/uploads/2012/02/logo.png" height="250" width="250" />';
  }
  function mc_admin_vier()
  {
    echo '<ul>
<li><a href="http://profenter.de/portal/gruppen/minecraft-admin-fur-wordpress/frontpage/">' . __("Projekt-Homepage", 'minecraft-admin') . '</a></li>
<li><a href="http://profenter.de/portal/gruppen/minecraft-admin-fur-wordpress/forum/">' . __("Hilfe", 'minecraft-admin') . '</a></li>
<li><a href="http://downloads.profenter.de/minecraft-admin-fur-wordpress/">' . __("Download", 'minecraft-admin') . '</a></li>
<li><a href="http://profenter.de/portal/gruppen/minecraft-admin-fur-wordpress/home/">' . __("News", 'minecraft-admin') . '</a></li>
<li><a href="http://wordpress.org/extend/plugins/minecraft-admin/" target="_blank">' . __("auf Wordpress", 'minecraft-admin') . '</a></li>
</ul>';
  }
  function mc_admin_fuenf()
  {
    echo '<a href="?page=minecraft-admin&amp;site=neuinstallieren">' . __("neu installieren", "minecraft-admin") . '</a>';
  }
  function cronjob()
  {
    settings_fields('mc_settings');
    $options = get_option('mc_settings_options');
    $prog    = $options['pfad'] . "aufgaben.crontab";
    $prog2   = $options['pfad'] . "aufgaben.crontab2";
    if (isset($_GET["id"])) {
      $properties = file($prog);
      unlink($prog);
      exec("touch " . $prog);
      $dat = fopen($prog, "w");
      unset($properties[$_GET["id"]]);
      $properties = array_values($properties);
      foreach ($properties as $key => $value) {
        if (!empty($value) or $value != " ") {
          fwrite($dat, $value);
        } //!empty($value) or $value != " "
      } //$properties as $key => $value
      fclose($dat);
      exec("crontab $prog");
      echo '<meta http-equiv="refresh" content="0; URL=admin.php?page=minecraft-admin?site=cronjob"> ';
    } //isset($_GET["id"])
    if (!empty($_POST["befehl"])) {
      if (is_array($_POST["min"])) {
        foreach ($_POST["min"] as $key => $value) {
          if (!isset($min)) {
            $min = $value;
          } //!isset($min)
          else {
            $min .= ',' . $value;
          }
        } //$_POST["min"] as $key => $value
      } //is_array($_POST["min"])
      else {
        $min = $_POST["min"];
      }
      if ($min == "") {
        $min = "*";
      } //$min == ""
      if (is_array($_POST["hour"])) {
        foreach ($_POST["hour"] as $key => $value) {
          if (!isset($hour)) {
            $hour = $value;
          } //!isset($hour)
          else {
            $hour .= ',' . $value;
          }
        } //$_POST["hour"] as $key => $value
      } //is_array($_POST["hour"])
      else {
        $hour = $_POST["hour"];
      }
      if ($hour == "") {
        $hour = "*";
      } //$hour == ""
      if (is_array($_POST["day"])) {
        foreach ($_POST["day"] as $key => $value) {
          if (!isset($day)) {
            $day = $value;
          } //!isset($day)
          else {
            $day .= ',' . $value;
          }
        } //$_POST["day"] as $key => $value
      } //is_array($_POST["day"])
      else {
        $day = $_POST["day"];
      }
      if ($day == "") {
        $day = "*";
      } //$day == ""
      if (is_array($_POST["month"])) {
        foreach ($_POST["month"] as $key => $value) {
          if (!isset($month)) {
            $month = $value;
          } //!isset($month)
          else {
            $month .= ',' . $value;
          }
        } //$_POST["month"] as $key => $value
      } //is_array($_POST["month"])
      else {
        $month = $_POST["month"];
      }
      if ($month == "") {
        $month = "*";
      } //$month == ""
      if (is_array($_POST["week"])) {
        foreach ($_POST["week"] as $key => $value) {
          if (!isset($week)) {
            $week = $value;
          } //!isset($week)
          else {
            $week .= ',' . $value;
          }
        } //$_POST["week"] as $key => $value
      } //is_array($_POST["week"])
      else {
        $week = $_POST["week"];
      }
      if ($week == "") {
        $week = "*";
      } //$week == ""
      if (!is_file($prog)) {
        exec("touch " . $prog);
      } //!is_file($prog)
      if ($_POST["befehl"] == "command") {
        $befehl = "sh /etc/init.d/minecraft command " . $_POST["mcbefehl"];
      } //$_POST["befehl"] == "command"
      else {
        $befehl = "sh /etc/init.d/minecraft " . $_POST["befehl"];
      }
      print(__('Ok, erstelle wiederkehrende Aufgabe.', 'minecraft-admin'));
      exec("echo \"$min $hour $day $month $week $befehl\" >> $prog");
      exec("crontab $prog");
      print(__('Erfolgreich ausgeführt', 'minecraft-admin'));
    } //!empty($_POST["befehl"])
    echo '<table><tr><th>' . __('Id', 'minecraft-admin') . '</th><th>' . __('Minute', 'minecraft-admin') . '</th><th>' . __('Stunde', 'minecraft-admin') . '</th><th>' . __('Tag', 'minecraft-admin') . '</th><th>' . __('Monat', 'minecraft-admin') . '</th><th>' . __('Wochentag', 'minecraft-admin') . '</th><th>' . __('Befehl', 'minecraft-admin') . '</th><th>' . __("Löschen", "minecraft-admin") . '</th></tr>';
    $properties = file($prog);
    foreach ($properties as $key => $value) {
      $explode = explode("sh /etc/init.d/minecraft", $value);
      $leer    = explode(" ", $explode[0]);
      foreach ($leer as $zähler => $zahl) {
        if ($zahl == '*') {
          $leer[$zähler] = "alle";
        } //$zahl == '*'
      } //$leer as $zähler => $zahl
      $bef    = explode(" ", $explode[1]);
      $bef[1] = str_replace("\n", "", $bef[1]);
      if ($bef[1] == "command") {
        $befehl = __('Minecraft Befehl', 'minecraft-admin') . ': <div style="color:green;">';
        foreach ($bef as $id => $rest) {
          if ($id != 0 && $id != 1) {
            $befehl .= $rest . ' ';
          } //$id != 0 && $id != 1
        } //$bef as $id => $rest
        $befehl .= '</div>';
      } //$bef[1] == "command"
      elseif ($bef[1] == "start") {
        $befehl = __('Starten', 'minecraft-admin');
      } //$bef[1] == "start"
        elseif ($bef[1] == "stop") {
        $befehl = __('Stoppen', 'minecraft-admin');
      } //$bef[1] == "stop"
        elseif ($bef[1] == "restart") {
        $befehl = __('Neustarten', 'minecraft-admin');
      } //$bef[1] == "restart"
        elseif ($bef[1] == "backup") {
        $befehl = __('Backupen', 'minecraft-admin');
      } //$bef[1] == "backup"
      echo '<tr><td>' . ($key + 1) . '.</td><td>' . $leer[0] . '</td><td>' . $leer[1] . '</td><td>' . $leer[2] . '</td><td>' . $leer[3] . '</td><td>' . $leer[4] . '</td><td>' . $befehl . '</td><td><a href="admin.php?page=minecraft-admin?site=cronjob&id=' . $key . '">' . __("Löschen", "minecraft-admin") . '</a></td></tr>';
      unset($befehl);
    } //$properties as $key => $value
    echo '</table><h2>' . __('Neue wiederkehrende Aktionen', 'minecraft-admin') . '</h2>
' . __('Es sind immer Mehrfachauswahlen möglich.', 'minecraft-admin') . '
<form action="" method="POST">
  <p>
    ' . __('Minute', 'minecraft-admin') . ':<select name="min[]" size="61" multiple>
      <option value="0">0</option><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="4">4</option><option value="5">5</option><option value="6">6</option><option value="7">7</option><option value="8">8</option><option value="9">9</option><option value="10">10</option><option value="11">11</option><option value="12">12</option><option value="13">13</option><option value="14">14</option><option value="15">15</option><option value="16">16</option><option value="17">17</option><option value="18">18</option><option value="19">19</option><option value="20">20</option><option value="21">21</option><option value="22">22</option><option value="23">23</option><option value="24">24</option><option value="25">25</option><option value="26">26</option><option value="27">27</option><option value="28">28</option><option value="29">29</option><option value="30">30</option><option value="31">31</option><option value="32">32</option><option value="33">33</option><option value="34"
>34</option><option value="35">35</option><option value="36">36</option><option value="37">37</option><option value="38">38</option><option value="39">39</option><option value="40">40</option><option value="41">41</option><option value="42">42</option><option value="43">43</option><option value="44">44</option><option value="45">45</option><option value="46">46</option><option value="47">47</option><option value="48">48</option><option value="49">49</option><option value="50">50</option><option value="51">51</option><option value="52">52</option><option value="53">53</option><option value="54">54</option><option value="55">55</option><option value="56">56</option><option value="57">57</option><option value="58">58</option><option value="59">59</option><option value="*">' . __('zur jeder Minute', 'minecraft-admin') . '</option>
    </select>

    ' . __('Stunde', 'minecraft-admin') . ':<select name="hour[]" size="25" multiple>
    <option value="0">0</option><option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="4">4</option><option value="5">5</option><option value="6">6</option><option value="7">7</option><option value="8">8</option><option value="9">9</option><option value="10">10</option><option value="11">11</option><option value="12">12</option><option value="13">13</option><option value="14">14</option><option value="15">15</option><option value="16">16</option><option value="17">17</option><option value="18">18</option><option value="19">19</option><option value="20">20</option><option value="21">21</option><option value="22">22</option><option value="23">23</option><option value="*">' . __('zur jeder Stunde', 'minecraft-admin') . '</option>
    </select>

   ' . __('Tag', 'minecraft-admin') . ':<select name="day[]" size="32" multiple>
<option value="1">1</option><option value="2">2</option><option value="3">3</option><option value="4">4</option><option value="5">5</option><option value="6">6</option><option value="7">7</option><option value="8">8</option><option value="9">9</option><option value="10">10</option><option value="11">11</option><option value="12">12</option><option value="13">13</option><option value="14">14</option><option value="15">15</option><option value="16">16</option><option value="17">17</option><option value="18">18</option><option value="19">19</option><option value="20">20</option><option value="21">21</option><option value="22">22</option><option value="23">23</option><option value="24">24</option><option value="25">25</option><option value="26">26</option><option value="27">27</option><option value="28">28</option><option value="29">29</option><option value="30">30</option><option value="31">31</option><option value="*">' . __('an jedem Tag', 'minecraft-admin') . '</option>
    </select>

   ' . __('Monat', 'minecraft-admin') . ':<select name="month[]" size="13" multiple>
<option value="1">Januar</option><option value="2">Februar</option><option value="3">März</option><option value="4">April</option><option value="5">Mai</option><option value="6">Juni</option><option value="7">Juli</option><option value="8">August</option><option value="9">Semptemer</option><option value="10">Oktober</option><option value="11">November</option><option value="12">Dezember</option><option value="*">' . __('an allen Monaten', 'minecraft-admin') . '</option>
    </select>

   ' . __('Wochentag', 'minecraft-admin') . ':<select name="week[]" size="8" multiple>
<option value="0">Sonntag</option><option value="1">Montag</option><option value="2">Dienstag</option><option value="3">Mittwoch</option><option value="4">Donnerstag</option><option value="5">Freitag</option><option value="6">Sammstag</option><option value="*">' . __('An allen Wochentagen', 'minecraft-admin') . '</option>
    </select><br /><br />
   ' . __('Befehl', 'minecraft-admin') . ':<select name="befehl" size="1">
<option value="start">' . __('Starten', 'minecraft-admin') . '</option>
<option value="stop">' . __('Stoppen', 'minecraft-admin') . '</option>
<option value="restart">' . __('Neustarten', 'minecraft-admin') . '</option>
<option value="backup">' . __('Backupen', 'minecraft-admin') . '</option>
<option value="command">' . __('Minecraft-Befehl(unten)', 'minecraft-admin') . '</option>
    </select><br />
' . __('Minecraft Befehl', 'minecraft-admin') . ':<input type="text" name="mcbefehl" placeholder="say ' . __('hi, wie geht es?', 'minecraft-admin') . '">
    <input type="submit" name="absenden" value="' . __('Absenden', 'minecraft-admin') . '">
  </p>
</form>';
  }
  function mc_server_properties()
  {
    settings_fields('mc_settings');
    $options = get_option('mc_settings_options');
    if (!empty($_POST["mc_server_properties_options"])) {
      $fp = fopen($options['pfad'] . "server.properties", "w+");
      fwrite($fp, "#Diese Datei wurde automatisch generiert von MC Admin fuer Wordpress um " . date('Y-m-d H:i:s') . ". Fuer mehr Informationen besuche http://profenter.de/portal/gruppen/minecraft-admin-fur-wordpress/frontpage/\r\n#This file was automatically generated by MC Admin for WordPress at " . date('Y-m-d H:i:s') . ". For more information visit http://profenter.de/portal/gruppen/minecraft-admin-fur-wordpress/frontpage/\r\n");
      foreach ($_POST["mc_server_properties_options"] as $key => $value) {
        $action    = $key . "=" . $value;
        $aenderung = sprintf("%s\r\n", $action);
        fwrite($fp, $aenderung);
      } //$_POST["mc_server_properties_options"] as $key => $value
      fclose($fp);
    } //!empty($_POST["mc_server_properties_options"])
    $zaehler    = 0;
    $properties = file($options['pfad'] . "server.properties");
    echo '	<div class="wrap"><h2>Einstellungen</h2><form method="post" action=""><table class="form-table">';
    $i = 0;
    foreach ($properties as $key => $value) {
      if ($i > 1) {
        $value = explode('=', $value);
        echo '<tr valign="top"><th scope="row">' . $value[0] . '</th><td><input type="text" name="mc_server_properties_options[' . $value[0] . ']" value="' . $value[1] . '" /></td></tr>';
      } //$i > 1
      $i++;
    } //$properties as $key => $value
?></tr></table>
<p class="submit"><input type="submit" class="button-primary" value="<?php
    echo _e("Änderungen übernehmen", 'minecraft-admin');
?>" /></p>
</form></div><?php
  }
  function mc_admin_do_page()
  {
?>
<div class="wrap">
<h2>Einstellungen</h2>
<form method="post" action="options.php">
<?php
    settings_fields('mc_settings');
    $options = get_option('mc_settings_options');
    $this->generate_init(true);
?>
<table class="form-table">
<tr valign="top">
<th scope="row"><?php
    _e('Pfad', 'minecraft-admin');
?></th>
<td><input type="text" name="mc_settings_options[pfad]" value="<?php
    echo $options['pfad'];
?>" /></td>
<td><?php
    echo $this->mc_info("Pfad");
?></td>
</tr>
<tr valign="top">
<th scope="row"><?php
    _e('Backup-Pfad', 'minecraft-admin');
?></th>
<td><input type="text" name="mc_settings_options[backup]" value="<?php
    echo $options['backup'];
?>" /></td>
<td><?php
    echo $this->mc_info("backup");
?></td>
</tr>
<tr valign="top">
<th scope="row">.jar <?php
    _e('Datei', 'minecraft-admin');
?></th>
<td><input type="text" name="mc_settings_options[jar]" value="<?php
    echo $options['jar'];
?>" /></td>
<td><?php
    echo $this->mc_info("jar");
?></td>
</tr>
<tr valign="top">
<th scope="row"><?php
    _e('User', 'minecraft-admin');
?></th>
<td><input type="text" name="mc_settings_options[users]" value="<?php
    echo $options['users'];
?>" /></td>
<td><?php
    echo $this->mc_info("users");
?></td>
</tr>
<tr valign="top">
<th scope="row"><?php
    _e('RAM', 'minecraft-admin');
?></th>
<td><input type="text" name="mc_settings_options[ram]" value="<?php
    echo $options['ram'];
?>" /></td>
<td><?php
    echo $this->mc_info("RAM");
?></td>
</tr>
<tr valign="top">
<th scope="row"><?php
    _e('CPU\'s', 'minecraft-admin');
?></th>
<td><input type="text" name="mc_settings_options[cpu]" value="<?php
    echo $options['cpu'];
?>" /></td>
<td><?php
    echo $this->mc_info("CPU");
?></td>
</tr>
<tr valign="top">
<th scope="row"><?php
    _e('Welten', 'minecraft-admin');
?></th>
<td><input type="text" name="mc_settings_options[worlds]" value="<?php
    echo $options['worlds'];
?>" /></td>
<td><?php
    echo $this->mc_info("worlds");
?></td>
</tr>
<tr valign="top">
<th scope="row"><?php
    _e('Maximale Anzahl an Logs', 'minecraft-admin');
?></th>
<td><input type="text" name="mc_settings_options[log]" value="<?php
    echo $options['log'];
?>" /></td>
<td><?php
    echo $this->mc_info("log");
?></td>
</tr>

<tr valign="top">
<th scope="row"><?php
    _e('Webserver Nutzer', 'minecraft-admin');
?></th>
<td><input type="text" name="mc_settings_options[webserver-nutzer]" value="<?php
    echo $options['webserver-nutzer'];
?>" /></td>
<td><?php
    echo $this->mc_info("webserver-nutzer");
?></td>
</tr>

</table>
<p class="submit">
<input type="submit" class="button-primary" value="<?php
    _e('Änderungen übernehmen', 'minecraft-admin');
?>" />
</p>
</form>
</div>
<?php
  }
  function mc_start()
  {
    settings_fields('mc_settings');
    $options = get_option('mc_settings_options');
    echo '<a href="admin.php?page=minecraft-admin?site=befehle&p=restart">' . __('Neustarten', 'minecraft-admin') . '</a> <a href="admin.php?page=minecraft-admin?site=befehle&p=start">' . __('Start', 'minecraft-admin') . '</a> <a href="admin.php?page=minecraft-admin?site=befehle&p=stop">' . __('Stop', 'minecraft-admin') . '</a><br /><form action="admin.php?page=minecraft-admin?site=befehle" method="POST"><input type="text" name="p" /><input type="submit" value="' . __('absenden', 'minecraft-admin') . '" /></form><br />';
    if (!empty($_GET["p"])) {
      $output = shell_exec('sh /etc/init.d/minecraft ' . $_GET["p"]);
      echo "<pre>" . $output . "</pre>";
    } //!empty($_GET["p"])
    else if (!empty($_POST["p"])) {
      $output = shell_exec('sh /etc/init.d/minecraft command "' . $_POST["p"] . '"');
      $output = str_replace("[0m", "", $output);
      $output = str_replace("[35m", "", $output);
      $output = explode('[INFO]', $output);
      echo "<pre>" . $output[1] . "</pre>";
    } //!empty($_POST["p"])
    echo '<br />';
    $users     = shell_exec('sh /etc/init.d/minecraft command "list"');
    $new_users = explode(']', $users);
    $new_users = str_replace("[0m", "", $new_users);
    $new_users = str_replace("[m", "", $new_users);
    echo $new_users[1];
    $outputs = shell_exec('sh /etc/init.d/minecraft status');
    echo "<pre>" . $outputs . "</pre>";
    $zaehler = 0;
    $log     = file($options['pfad'] . "server.log");
    $i       = sizeof($log);
    echo '<textarea cols="150" rows="' . $options['log'] . '">';
    while ($i--) {
      if ($zaehler == $options['log']) {
        break;
      } //$zaehler == $options['log']
      else {
        $log[$i] = str_replace("[0m", "", $log[$i]);
        $log[$i] = str_replace("[35m", "", $log[$i]);
        $log[$i] = str_replace("[33;22m", "", $log[$i]);
        $log[$i] = str_replace("[37;1m", "", $log[$i]);
        $log[$i] = str_replace("[m", "", $log[$i]);
        $log[$i] = str_replace("<", "[", $log[$i]);
        $log[$i] = str_replace(">", "]", $log[$i]);
        echo $log[$i];
        $zaehler++;
      }
    } //$i--
    echo "</textarea>";
  }
  function generate_init($kopieren)
  {
    settings_fields('mc_settings');
    $options = get_option('mc_settings_options');
    $script  = '#!/bin/bash
# /etc/init.d/minecraft
# version 0.3.6 2011-10-17 (YYYY-MM-DD)

### BEGIN INIT INFO
# Provides:minecraft
# Required-Start: $local_fs $remote_fs
# Required-Stop:$local_fs $remote_fs
# Should-Start:$network
# Should-Stop: $network
# Default-Start:2 3 4 5
# Default-Stop:0 1 6
# Short-Description: Minecraft server
# Description: the start/stop file by minecraft admin for wordpress
### END INIT INFO

#Settings
#Diese Datei wurde automatisch generiert von MC Admin fuer Wordpress um ' . date('Y-m-d H:i:s') . '. Fuer mehr Informationen besuche http://profenter.de/portal/gruppen/minecraft-admin-fur-wordpress/frontpage/
#This file was automatically generated by MC Admin for WordPress at ' . date('Y-m-d H:i:s') . ' . For more information visit http://profenter.de/portal/gruppen/minecraft-admin-fur-wordpress/frontpage/
SERVICE=\'' . $options['jar'] . '\'
OPTIONS=\'nogui\'
USERNAME=\'' . $options['webserver-nutzer'] . '\'
WORLDS=\'' . $options['worlds'] . '\'
MCPATH=\'' . $options['pfad'] . '\'
BACKUPPATH=\'' . $options['pfad'] . 'backup\'
CPU_COUNT=' . $options['cpu'] . '
INVOCATION="java -Xmx' . $options['ram'] . ' -Xms' . $options['ram'] . ' -XX:+UseConcMarkSweepGC -XX:+CMSIncrementalPacing -XX:ParallelGCThreads=$CPU_COUNT -XX:+AggressiveOpts -jar $SERVICE $OPTIONS"

ME=`whoami`
as_user() {
if [ $ME = $USERNAME ] ; then
 bash -c "$1"
else
 su - $USERNAME -c "$1"
fi
}

mc_start() {
  if  pgrep -u $USERNAME -f $SERVICE > /dev/null
then
 echo "$SERVICE' . __(' läuft bereits!', 'minecraft-admin') . '"
else
 echo "' . __('Starte', 'minecraft-admin') . ' $SERVICE..."
 cd $MCPATH
 as_user "cd $MCPATH && screen -dmS minecraft $INVOCATION"
 sleep 7
 if pgrep -u $USERNAME -f $SERVICE > /dev/null
 then
echo "$SERVICE ' . __('läuft nun.', 'minecraft-admin') . '"
 else
echo "' . __('Error!', 'minecraft-admin') . ' $SERVICE! ' . __('konnte nicht gestartet werden', 'minecraft-admin') . '"
 fi
fi
}

mc_saveoff() {
if pgrep -u $USERNAME -f $SERVICE > /dev/null
then
 echo "$SERVICE ' . __('läuft... speichere die Karte', 'minecraft-admin') . '"
 as_user "screen -p 0 -S minecraft -X eval \'stuff \"say ' . __('SERVER BACKUP GESTARTET. Server geht in den lese Modus...', 'minecraft-admin') . '\"\015\'"
 as_user "screen -p 0 -S minecraft -X eval \'stuff \"save-off\"\015\'"
 as_user "screen -p 0 -S minecraft -X eval \'stuff \"save-all\"\015\'"
 sync
 sleep 10
else
 echo "$SERVICE ' . __('läuft nicht. Nichts zum speichern.', 'minecraft-admin') . '"
fi
}

mc_saveon() {
if pgrep -u $USERNAME -f $SERVICE > /dev/null
then
 echo "$SERVICE ' . __('läuft nun... Aktiviere die Karte', 'minecraft-admin') . '"
 as_user "screen -p 0 -S minecraft -X eval \'stuff \"save-on\"\015\'"
 as_user "screen -p 0 -S minecraft -X eval \'stuff \"say ' . __('SERVER BACKUP ENDE. Server geht in den schreibe Modus...', 'minecraft-admin') . '\"\015\'"
else
 echo "$SERVICE ' . __('läuft nicht. Nichts zum aktivieren.', 'minecraft-admin') . '"
fi
}

mc_stop() {
if pgrep -u $USERNAME -f $SERVICE > /dev/null
then
 echo "' . __('Stoppe', 'minecraft-admin') . ' $SERVICE"
 as_user "screen -p 0 -S minecraft -X eval \'stuff \"say ' . __('Der Server wird in 10 Sekunden gestoppt. Die Map wird gespeichert...', 'minecraft-admin') . '\"\015\'"
 as_user "screen -p 0 -S minecraft -X eval \'stuff \"save-all\"\015\'"
 sleep 10
 as_user "screen -p 0 -S minecraft -X eval \'stuff \"stop\"\015\'"
 sleep 7
else
 echo "$SERVICE ' . __('läuft nicht.', 'minecraft-admin') . '"
fi
if pgrep -u $USERNAME -f $SERVICE > /dev/null
then
 echo "' . __('Error!', 'minecraft-admin') . ' $SERVICE! ' . __('konnte nicht gestartet werden', 'minecraft-admin') . '"
else
 echo "$SERVICE ' . __('ist gestoppt.', 'minecraft-admin') . '"
fi
}
mc_backup() {
echo "' . __('Lösche alte Datein...', 'minecraft-admin') . '"
as_user "cd $BACKUPPATH && find $BACKUPPATH -ctime +14 -exec rm -rf {} \;"
echo "' . __('Sichere die Minecraft Welten...', 'minecraft-admin') . '"
if [ -d $BACKUPPATH/${WORLD}_`date "+%Y.%m.%d_%H.%M"` ]
then
for i in 1 2 3 4 5 6
do
 if [ -d $BACKUPPATH/${WORLD}_`date "+%Y.%m.%d_%H.%M"`-$i ]
 then
continue
 else
as_user "cd $MCPATH && tar -czf $BACKUPPATH/_`date "+%Y.%m.%d_%H.%M"`-$i.tar.gz $WORLDS"
break
 fi
done
else
as_user "cd $MCPATH && tar -czf $BACKUPPATH/`date "+%Y.%m.%d_%H.%M"`.tar.gz $WORLDS"
echo "' . __('Welt gesichert', 'minecraft-admin') . '"
fi
echo "' . __('Backup fertig', 'minecraft-admin') . '"
}
mc_command() {
  command="$1";
  if pgrep -u $USERNAME -f $SERVICE > /dev/null
  then
    pre_log_len=`wc -l "$MCPATH/server.log" | awk \'{print $1}\'`
    as_user "screen -p 0 -S minecraft -X eval \'stuff \"$command\"\015\'"
    sleep .1 # assumes that the command will run and print to the log file in less than .1 seconds
    # print output
    # tail -n $[`wc -l "$MCPATH/server.log" | awk \'{print $1}\'`-$pre_log_len] "$MCPATH/server.log"
    tail -n 1 "$MCPATH/server.log"
  fi
}

#Start-Stop here
case "$1" in
start)
 mc_start
 ;;
stop)
 mc_stop
 ;;
restart)
 mc_stop
 mc_start
 ;;
backup)
 mc_saveoff
 mc_backup
 mc_saveon
 ;;
status)
 if pgrep -u $USERNAME -f $SERVICE > /dev/null
 then
echo "$SERVICE ' . __("läuft.", 'minecraft-admin') . '"
 else
echo "$SERVICE ' . __("läuft nicht.", 'minecraft-admin') . '"
    fi
    ;;
  command)
    if [ $# -gt 1 ]; then
      shift
mc_command "$*"
 else
echo "' . __('Bitte gebe einen Kommando ein (versuche \'help\' oder ?)', 'minecraft-admin') . '"
 fi
 ;;

*)
echo "' . __('Benutze:', 'minecraft-admin') . ' $0 {start|stop|backup|status|restart|command \"server command\"}"
  exit 1
  ;;
esac

exit 0';
    $ordner  = str_replace("/wp-admin", "", dirname($_SERVER["SCRIPT_FILENAME"])) . '/wp-content/plugins/minecraft-admin/';
    $this->ordner('minecraft_init_d.sh', $script, $ordner);
    if ($kopieren) {
      unlink("/etc/init.d/minecraft");
      copy(str_replace("/wp-admin", "", dirname($_SERVER["SCRIPT_FILENAME"])) . '/wp-content/plugins/minecraft-admin/minecraft_init_d.sh', "/etc/init.d/minecraft");
    } //$kopieren
    return $script;
  }
  function mc_install()
  {
    $oswebserver         = explode("(", $_SERVER['SERVER_SOFTWARE']);
    $os                  = str_replace(")", "", $oswebserver[1]);
    $webserver           = $webserver[1];
    $os_unterstuetzt     = false;
    $os_unter            = array(
      'Debian',
      'Ubuntu'
    );
    $os_unter_vielleicht = array(
      'Fedora',
      'openSUSE'
    );
    $os_nicht_unter      = array(
      'Windows'
    );
    foreach ($os_unter as $system) {
      if ($system == $os) {
        $os_unterstuetzt = true;
        break;
      } //$system == $os
    } //$os_unter as $system
    if ($os_unterstuetzt) {
      echo '<div id="message" class="updated"><p><strong>' . __("Dein Betriebssystem wird unterstützt.", "minecraft-admin") . '</strong></p></div>';
    } //$os_unterstuetzt
    else {
      $os_unterstuetzt_vielleicht = false;
      foreach ($os_unter_vielleicht as $system) {
        if ($system == $os) {
          $os_unterstuetzt_vielleicht = true;
          break;
        } //$system == $os
      } //$os_unter_vielleicht as $system
      if ($os_unterstuetzt_vielleicht) {
        echo '<div id="message" class="error"><p><strong>' . __("Für dein Betriebssystem liegen keine offizellen Testdaten vor. <br />Ein ähnliches Betriebssystem wird jedoch unterstützt, sodass es möglich ist, dass auf deinem Betriebssystem 'Minecraft Admin' läuft.", "minecraft-admin") . '</strong></p></div>';
      } //$os_unterstuetzt_vielleicht
      else {
        $os_unterstuetzt_nicht = false;
        foreach ($os_nicht_unter as $system) {
          if ($system == $os) {
            $os_unterstuetzt_nicht = true;
            break;
          } //$system == $os
        } //$os_nicht_unter as $system
        if ($os_unterstuetzt_nicht) {
          echo '<div id="message" class="error"><p><strong>' . __("Dein Betriebssystem wird nicht unterstützt.<br />Es wird von einer Installation abgeraten.", "minecraft-admin") . '</strong></p></div>';
        } //$os_unterstuetzt_nicht
        else {
          echo '<div id="message" class="updated"><p><strong>' . __("Für dein Betriebssystem liegen keine offizellen Testdaten vor.<br />Du kannst trotzdem versuchen, 'Minecraft Admin' zu installieren.", "minecraft-admin") . '</strong></p></div>';
        }
      }
    }
    echo '<br /><br />';
    if ($_GET["p"] == 1 || empty($_GET["p"])) {
      echo '<div class="wrap"><h2>' . __('Installieren', 'minecraft-admin') . '</h2><form method="post" action="options.php"><table class="form-table"><tr valign="top"><th scope="row">';
      settings_fields('mc_settings');
      $options = get_option('mc_settings_options');
      if ($options['webserver-nutzer'] == "") {
        $options['webserver-nutzer'] = "www-data";
      } //$options['webserver-nutzer'] == ""
      $pfad = $options['pfad'];
      if ($options['pfad'] == "") {
        $options['pfad'] = "/opt/minecraft/";
      } //$options['pfad'] == ""
      if ($options['jar'] == "") {
        $options['jar'] = "craftbukkit.jar";
      } //$options['jar'] == ""
      if ($options['worlds'] == "") {
        $options['worlds'] = "world,world_nether";
      } //$options['worlds'] == ""
      if ($options['cpu'] == "") {
        $options['cpu'] = "1";
      } //$options['cpu'] == ""
      if ($options['ram'] == "") {
        $options['ram'] = "1024M";
      } //$options['ram'] == ""
      if ($options['users'] == "") {
        $options['users'] = '';
      } //$options['users'] == ""
      if ($options['backup'] == "") {
        $options['backup'] = $options['pfad'] . 'backup/';
      } //$options['backup'] == ""
      $sel["orginal"] = ($options['server'] == "orginal") ? "selected" : "";
      $sel["bukkit"]  = ($options['server'] == "bukkit") ? "selected" : "";
      echo __('Pfad', 'minecraft-admin') . '</th><td><input type="text" name="mc_settings_options[pfad]" value="' . $options['pfad'] . '" /></td><td>' . $this->mc_info("Pfad") . '</td></tr>
<tr valign="top"><th scope="row">.jar ' . __('Datei', 'minecraft-admin') . '</th><td><input type="text" name="mc_settings_options[jar]" value="' . $options['jar'] . '" /></td><td>' . $this->mc_info("jar") . '</td></tr>
<tr valign="top"><th scope="row">' . __('Logs', 'minecraft-admin') . '</th><td><input type="text" name="mc_settings_options[log]" value="' . $options['log'] . '" /></td><td>' . $this->mc_info("log") . '</td></tr>
<tr valign="top"><th scope="row">' . __('Webserver-Nutzer', 'minecraft-admin') . '</th><td><input type="text" name="mc_settings_options[webserver-nutzer]" value="' . $options['webserver-nutzer'] . '" /></td><td>' . $this->mc_info("webserver-nutzer") . '</td> </tr>
<tr valign="top"><th scope="row">' . __('Welten', 'minecraft-admin') . '</th><td><input type="text" name="mc_settings_options[worlds]" value="' . $options['worlds'] . '" /></td><td>' . $this->mc_info("worlds") . '</td></tr>
<tr valign="top"><th scope="row">' . __('CPU\'s', 'minecraft-admin') . '</th><td><input type="text" name="mc_settings_options[cpu]" value="' . $options['cpu'] . '" /></td> <td>' . $this->mc_info("CPU") . '</td></tr>
<tr valign="top"><th scope="row">' . __('RAM', 'minecraft-admin') . '</th><td><input type="text" name="mc_settings_options[ram]" value="' . $options['ram'] . '" /></td><td>' . $this->mc_info("RAM") . '</td></tr>
<tr valign="top"><th scope="row">' . __('Backup-Pfad', 'minecraft-admin') . '</th><td><input type="text" name="mc_settings_options[backup]" value="' . $options['backup'] . '" /></td><td>' . $this->mc_info("backup") . '</td></tr>
<tr valign="top"><th scope="row">' . __('Minecraft Server', 'minecraft-admin') . '</th><td><select name="mc_settings_options[server]" size="1"><option value="orginal" ' . $sel["orginal"] . '>Orginal</option><option value="bukkit" ' . $sel["bukkit"] . '>Bukkit</option></select></td><td>' . $this->mc_info("server") . '</td></tr>
<tr valign="top"><th scope="row">' . __('Users', 'minecraft-admin') . '</th><td><input type="text" name="mc_settings_options[users]" value="' . $options['users'] . '" /></td><td>' . $this->mc_info("users") . '</td></tr></table><p class="submit"><input type="submit" class="button-primary" value="' . __('Änderungen übernehmen', 'minecraft-admin') . '" /></p></form>';
      if (!empty($pfad)) {
        echo '<form method="post" action="admin.php?page=minecraft-admin?site=installieren&p=2"><p class="submit"><input type="submit" class="button-primary" value="' . __('Weiter zu schritt 2', 'minecraft-admin') . '" /></p></form>';
      } //!empty($pfad)
      echo '</div>';
    } //$_GET["p"] == 1 || empty($_GET["p"])
    else if ($_GET["p"] == 2) {
      $script = $this->generate_init(false);
      settings_fields('mc_settings');
      $options = get_option('mc_settings_options');
      if ($options['server'] == "orginal") {
        $down = 'https://s3.amazonaws.com/MinecraftDownload/launcher/minecraft_server.jar?';
      } //$options['server'] == "orginal"
      elseif ($options['server'] == "bukkit") {
        $down = 'http://dl.bukkit.org/latest-rb/craftbukkit.jar';
      } //$options['server'] == "bukkit"
      if ($os == "Debian" or $os == "Ubuntu") {
        $installer = '
#!/bin/bash

#Diese Datei wurde automatisch generiert von MC Admin fuer Wordpress um ' . date('Y-m-d H:i:s') . '. Fuer mehr Informationen besuche http://profenter.de/portal/gruppen/minecraft-admin-fur-wordpress/frontpage/
#This file was automatically generated by MC Admin for WordPress at ' . date('Y-m-d H:i:s') . ' . For more information visit http://profenter.de/portal/gruppen/minecraft-admin-fur-wordpress/frontpage/

echo \'' . __('Willkommen zum Installer fuer Minecraft. Dieser Installiert alle benötigten Packet und Datein. Um Abzubrechen, drücke STRG + C.', 'minecraft-admin') . '\'
read -p "' . __('Drücke [Enter], um fortzufahren...', 'minecraft-admin') . '" readEnterKey
mv ./minecraft_init_d.sh ./minecraft
cp ./minecraft /etc/init.d/
chmod a+x /etc/init.d/minecraft
chmod 0777  /etc/init.d/
chmod 0777  /etc/init.d/minecraft
chown ' . $options['webserver-nutzer'] . ':' . $options['webserver-nutzer'] . ' -R /etc/init.d/minecraft
update-rc.d minecraft defaults
mkdir ' . $options['pfad'] . '
mkdir ' . $options['backup'] . '
cd ' . $options['pfad'] . '
wget \'' . $down . '\' -O ' . $options['jar'] . '
chown ' . $options['webserver-nutzer'] . ':' . $options['webserver-nutzer'] . ' -R ' . $options['pfad'] . '
echo \'' . __('Rechte wurden gesetzt', 'minecraft-admin') . '\'
apt-get install screen sun-java6-jre tar
echo \'' . __('Bitte wähle "/usr/lib/jvm/java-6-sun/jre/bin/java" aus.', 'minecraft-admin') . '\'
echo \'...\'
echo \'...\'
echo \'...\'
read -p "' . __('Drücke [Enter], um fortzufahren...', 'minecraft-admin') . '" readEnterKey
update-alternatives --config java
echo \'' . __('Starte Minecraft .....', 'minecraft-admin') . '\'
/etc/init.d/minecraft start';
      } //$os == "Debian" or $os == "Ubuntu"
      else if ($os == "openSUSE" or $os == "Fedora") {
        $installer = '
#!/bin/bash

#Diese Datei wurde automatisch generiert von MC Admin fuer Wordpress um ' . date('Y-m-d H:i:s') . '. Fuer mehr Informationen besuche http://profenter.de/portal/gruppen/minecraft-admin-fur-wordpress/frontpage/
#This file was automatically generated by MC Admin for WordPress at ' . date('Y-m-d H:i:s') . ' . For more information visit http://profenter.de/portal/gruppen/minecraft-admin-fur-wordpress/frontpage/

echo \'' . __('Willkommen zum Installer fuer Minecraft. Dieser Installiert alle benötigten Packet und Datein. Um Abzubrechen, drücke STRG + C.', 'minecraft-admin') . '\'
read -p "' . __('Drücke [Enter], um fortzufahren...', 'minecraft-admin') . '" readEnterKey
mv ./minecraft_init_d.sh ./minecraft
cp ./minecraft /etc/init.d/
chmod a+x /etc/init.d/minecraft
chmod 0777  /etc/init.d/
chmod 0777  /etc/init.d/minecraft
chown ' . $options['webserver-nutzer'] . ':' . $options['webserver-nutzer'] . ' -R /etc/init.d/minecraft
update-rc.d minecraft defaults
mkdir ' . $options['pfad'] . '
mkdir ' . $options['backup'] . '
cd ' . $options['pfad'] . '
wget \'' . $down . '\' -O ' . $options['jar'] . '
chown ' . $options['webserver-nutzer'] . ':' . $options['webserver-nutzer'] . ' -R ' . $options['pfad'] . '
echo \'' . __('Rechte wurden gesetzt', 'minecraft-admin') . '\'
yum install screen sun-java6-jre tar
echo \'' . __('Bitte wähle "/usr/lib/jvm/java-6-sun/jre/bin/java" aus.', 'minecraft-admin') . '\'
echo \'...\'
echo \'...\'
echo \'...\'
read -p "' . __('Drücke [Enter], um fortzufahren...', 'minecraft-admin') . '" readEnterKey
update-alternatives --config java
echo \'' . __('Starte Minecraft .....', 'minecraft-admin') . '\'
/etc/init.d/minecraft start';
      } //$os == "openSUSE" or $os == "Fedora"
      else {
        echo __("Da für dein Betriebssystem keine Testdaten vorliegen, kann kein automatisches Installerscript erstellt werden. Die Schritte müssen Manuel durchgrführt werden. <br /><br />
<ul><li>Installiere Java</li></ul> ", "minecraft-admin");
        $installer = '
#!/bin/bash

#Diese Datei wurde automatisch generiert von MC Admin fuer Wordpress um ' . date('Y-m-d H:i:s') . '. Fuer mehr Informationen besuche http://profenter.de/portal/gruppen/minecraft-admin-fur-wordpress/frontpage/
#This file was automatically generated by MC Admin for WordPress at ' . date('Y-m-d H:i:s') . ' . For more information visit http://profenter.de/portal/gruppen/minecraft-admin-fur-wordpress/frontpage/

echo \'' . __('Willkommen zum Installer fuer Minecraft. Dieser Installiert alle benötigten Packet und Datein. Um Abzubrechen, drücke STRG + C.', 'minecraft-admin') . '\'
read -p "' . __('Drücke [Enter], um fortzufahren...', 'minecraft-admin') . '" readEnterKey
mv ./minecraft_init_d.sh ./minecraft
cp ./minecraft /etc/init.d/
chmod a+x /etc/init.d/minecraft
chmod 0777  /etc/init.d/
chmod 0777  /etc/init.d/minecraft
chown ' . $options['webserver-nutzer'] . ':' . $options['webserver-nutzer'] . ' -R /etc/init.d/minecraft
update-rc.d minecraft defaults
mkdir ' . $options['pfad'] . '
mkdir ' . $options['backup'] . '
cd ' . $options['pfad'] . '
wget \'' . $down . '\' -O ' . $options['jar'] . '
chown ' . $options['webserver-nutzer'] . ':' . $options['webserver-nutzer'] . ' -R ' . $options['pfad'] . '
echo \'' . __('Starte Minecraft .....', 'minecraft-admin') . '\'
/etc/init.d/minecraft start';
      }
      $ordner = str_replace("/wp-admin", "", dirname($_SERVER["SCRIPT_FILENAME"])) . '/wp-content/plugins/minecraft-admin/';
      $this->ordner('installer.sh', $installer, $ordner);
      if (!is_file($ordner . '/minecraft_init_d.sh')) {
        echo '<div id="message" class="error"><p><strong>' . sprintf(__("Die Datei %s konnte nicht erstellt werden. Erstelle sie manuell.", "minecraft-admin"), "minecraft_init_d.sh") . '</strong></p></div>';
        echo $ordner . 'minecraft_init_d.sh<br><textarea>' . $script . '</textarea><br><br>';
      } //!is_file($ordner . '/minecraft_init_d.sh')
      if (!is_file($ordner . '/installer.sh')) {
        echo '<div id="message" class="error"><p><strong>' . sprintf(__("Die Datei %s konnte nicht erstellt werden. Erstelle sie manuell.", "minecraft-admin"), "installer.sh") . '</strong></p></div>';
        echo $ordner . 'installer.sh<br><textarea>' . $installer . '</textarea><br><br>';
      } //!is_file($ordner . '/installer.sh')
      echo '<form method="post" action="admin.php?page=minecraft-admin?site=installieren&p=3"><p class="submit"><input type="submit" class="button-primary" value="' . __('Weiter zu Schritt 3', 'minecraft-admin') . '" /></p></form><br><br><br><br>';
    } //$_GET["p"] == 2
    else if ($_GET["p"] == 3) {
      if (!is_file('/etc/init.d/minecraft')) {
        $ordner      = str_replace("/wp-admin", "", dirname($_SERVER["SCRIPT_FILENAME"])) . '/wp-content/plugins/minecraft-admin';
        $befehl_root = 'cd ' . $ordner . ' && sh ./installer.sh';
        $befehl_sudo = 'cd ' . $ordner . ' && sudo sh ./installer.sh';
        echo __('Fast fertig. Um den Installer zu beenden, fühere den folgenden Befehl aus:', 'minecraft-admin');
        if ($os == "Ubuntu") {
          echo '<br><textarea cols="150">' . $befehl_sudo . '</textarea>';
        } //$os == "Ubuntu"
        else {
          echo '<br><textarea cols="150">' . $befehl_root . '</textarea>';
        }
        echo '<br><form method="post" action="admin.php?page=minecraft-admin?site=installieren&p=3"><p class="submit"><input type="submit" class="button-primary" value="' . __('Weiter zu Schritt 4', 'minecraft-admin') . '" /></p></form>';
      } //!is_file('/etc/init.d/minecraft')
      else {
        settings_fields('mc_settings');
        update_option('installiert', "ja");
        echo '<div id="message" class="updated"><p><strong>' . __('<br>Glückwunsch. Dein Minecraft sollte nun installiert worden sein. Prüfe dies nach, indem du dich auf dem Server einlogst.', 'minecraft-admin') . '</strong></p></div>';
        echo '<div class="wrap"><form method="post" action="admin.php?page=minecraft-admin"><p class="submit"><input type="submit" class="button-primary" value="' . __('Fertig stellen', 'minecraft-admin') . '" /></p></form></div>';
      }
    } //$_GET["p"] == 3
    else if ($_GET["p"] == 4) {
    } //$_GET["p"] == 4
  }
  function ordner($datei, $inhalt, $ordner)
  {
    $fp = fopen($ordner . $datei, "w+");
    fwrite($fp, $inhalt);
    fclose($fp);
    if (file_exists($ordner . $datei)) {
      return __("Die Datei $datei ist erstellt worden.<br>", 'minecraft-admin');
    } //file_exists($ordner . $datei)
    else {
      return __("Der Ordner ist nicht beschreibbar. Erstelle die Datei $datei im Ordner $ordner und füge die Inhalt von unten ein.<br><br>", 'minecraft-admin');
    }
  }
  function mc_admin_validate($input)
  {
    if (!empty($input['pfad']))
      $input['pfad'] = wp_filter_nohtml_kses($input['pfad']);
    if (!empty($input['jar']))
      $input['jar'] = wp_filter_nohtml_kses($input['jar']);
    if (!empty($input['webserver-nutzer']))
      $input['webserver-nutzer'] = wp_filter_nohtml_kses($input['webserver-nutzer']);
    if (!empty($input['users']))
      $input['users'] = wp_filter_nohtml_kses($input['users']);
    if (!empty($input['log_max']))
      $input['log'] = wp_filter_nohtml_kses($input['log']);
    return $input;
  }
  function mc_info($frage)
  {
    switch ($frage) {
      case ("CPU"):
        return __("Hier kannst du einstellen, wie viel CPU's von Minecraft benutzt werden. Falls du nicht weißt, wie viele du hast, trage &bdquo;1&rdquo; ein.", 'minecraft-admin');
        break;
      case ("RAM"):
        return __("Hier kannst du einstellen, wie viel RAM(Arbeitsspeicher) von Minecraft benutzt werden. Falls du nicht weißt, wie viel du hast, frage deinen Hoster. Falls du nicht weiß, wie viel Arbeitspeicher angemessen ist, lasse den Standartwert von &bdquo;1024M&rdquo;", 'minecraft-admin');
        break;
      case ("Pfad"):
        return __("Gebe hier den Pfad ein, wo der Minecraft Ordner liegt bzw. wo Minecraft hininstalliert werden soll.", 'minecraft-admin');
        break;
      case ("jar"):
        return __("Gebe hier den Name der Datei ein, die zum Start des Servers ausgeführt werden soll.", 'minecraft-admin');
        break;
      case ("users"):
        return __("Gebe hier die Namen der Wordpress Nutzer ein (durch ein Komma getrennt), die auf dieses Interface Zugriff haben sollen. Administratoren haben immer Zugriff.", 'minecraft-admin');
        break;
      case ("worlds"):
        return __("Gebe hier die Namen der Minecraft Welten ein. Sie werden benötigt, um das Backup System zu ermöglichen.", 'minecraft-admin');
        break;
      case ("webserver-nutzer"):
        return __("Gebe hier den Name des Webserver Nutzer ein.", 'minecraft-admin');
        break;
      case ("log"):
        return __("Gebe hier die Anzahl an Logs an, die du angezeigt bekommen möchtest.", 'minecraft-admin');
        break;
      case ("backup"):
        return __("Gebe hier den Pfad ein, wo der Minecraft-Backup Ordner liegt bzw. wo Minecraft-Backup hininstalliert werden soll.", 'minecraft-admin');
        break;
      case ("server"):
        return __("Hier kannst du auswählen, ob du einen orginal Minecraft Server oder einen Bukkit Server willst.", 'minecraft-admin');
        break;
    } //$frage
  }
  function filebrowser()
  {
    wp_enqueue_style('filebrowser-style');
    settings_fields('mc_settings');
    $options = get_option('mc_settings_options');
    if (empty($_GET['path']))
      $_GET['path'] = "/";
    $path = $_GET['path'];
    if (!empty($_GET["lochen"])) {
      $res  = lochen_verzeichnis($options['pfad'] . $path);
      $path = substr($path, 0, strrpos($path, "/"));
      switch ($res) {
        case 0:
          echo __("Das Verzeichnis wurde korrekt gelöscht.", 'minecraft-admin');
          break;
        case -1:
          echo __("Fehler: Das ist kein Verzeichnis", 'minecraft-admin');
          break;
        case -2:
          echo __("Fehler: Das Verzeichnis konnte nicht gelöscht werden. Grund: Unbekannt", 'minecraft-admin');
          break;
        case -3:
          echo __("Fehler: Das Verzeichnis konnte nicht gelöscht werden. Grund: Dateityp unbekannt", 'minecraft-admin');
          break;
        default:
          echo __("Fehler: Das Verzeichnis konnte nicht gelöscht werden. Grund: Die Löschfunktion scheint Fehlerhaft zu sein. Informiere den Author.", 'minecraft-admin');
          break;
      } //$res
      echo '<br />';
    } //!empty($_GET["lochen"])
    if (!empty($_FILES["datei"]["tmp_name"])) {
      $uploadFile = $options['pfad'] . $path . '/' . $_FILES['datei']['name'];
      echo "<pre>";
      if (move_uploaded_file($_FILES['datei']['tmp_name'], $uploadFile)) {
        echo _e("Die Datei wurde erfolgreich hochgeladen.", 'minecraft-admin');
      } //move_uploaded_file($_FILES['datei']['tmp_name'], $uploadFile)
      else {
        echo _e("Datei konnte nicht hochgeladen werden.", 'minecraft-admin');
      }
      echo "</pre>";
    } //!empty($_FILES["datei"]["tmp_name"])
    else if (!empty($_POST["neu"])) {
      rename($options['pfad'] . $path, $options['pfad'] . substr($path, 0, strrpos($path, "/")) . '/' . $_POST["neu"]);
      $path = substr($path, 0, strrpos($path, "/")) . '/' . $_POST["neu"];
    } //!empty($_POST["neu"])
    else if (!empty($_POST["neuerstellen"])) {
      var_dump(strpos($_POST["neuerstellen"], '.'));
      if (strpos($_POST["neuerstellen"], '.')) {
        $path = $path . '/' . $_POST["neuerstellen"];
        $fp   = fopen($options['pfad'] . $path, "w+");
        fwrite($fp, "#test");
        fclose($fp);
        clearstatcache();
      } //strpos($_POST["neuerstellen"], '.')
      else {
        mkDir($options['pfad'] . $path . '/' . $_POST["neuerstellen"]);
      }
    } //!empty($_POST["neuerstellen"])
    echo '<a href="admin.php?page=minecraft-admin?site=filebrowser&path=/">Minecraft</a>/';
    if ($path != '' or $path != '/') {
      $expath  = explode('/', $path);
      $gesamnt = count($expath);
      for ($i = 0; $i < $gesamnt; $i++) {
        $url = '';
        for ($r = 0; $r < $i; $r++) {
          $url .= '/' . $expath[$r + 1];
        } //$r = 0; $r < $i; $r++
        if (!empty($expath[$i])) {
          echo '<a href="admin.php?page=minecraft-admin?site=filebrowser&path=' . $url . '">' . $expath[$i] . '</a>';
          if (!is_file($options["pfad"] . $url)) {
            echo '/';
          } //!is_file($options["pfad"] . $url)
        } //!empty($expath[$i])
      } //$i = 0; $i < $gesamnt; $i++
    } //$path != '' or $path != '/'
    echo '<br>';
    if (is_file($options["pfad"] . $path)) {
      if (isset($_POST["inhalt"])) {
        $fp = fopen($options['pfad'] . $path, "w+");
        fwrite($fp, str_replace('\\', "", $_POST["inhalt"]));
        fclose($fp);
        clearstatcache();
      } //isset($_POST["inhalt"])
      if (substr($path, 0, strrpos($path, "/")) == "") {
        $zuruck = "admin.php?page=minecraft-admin?site=filebrowser&path=/";
      } //substr($path, 0, strrpos($path, "/")) == ""
      else {
        $zuruck = "admin.php?page=minecraft-admin?site=filebrowser&path=" . substr($path, 0, strrpos($path, "/"));
      }
      echo '<div class="wrap"><h2>' . $path . '</h2><a href="' . $zuruck . '">zurück</a><form method="post" action=""><textarea name="inhalt" rows="25" cols="100">';
      $datei = file($options['pfad'] . $path);
      foreach ($datei as $key => $value) {
        $ausgabe_datei .= $value;
      } //$datei as $key => $value
      echo $ausgabe_datei . '</textarea><p class="submit"><input type="submit" class="button-primary" value="' . __("Änderungen übernehmen", 'minecraft-admin') . '" /></p></form></div><form method="POST" action="">Neuer Name: <input type="text" name="neu" /><input type="submit" class="button-primary" value="' . __("umbenennen", 'minecraft-admin') . '" /></form><a href="admin.php?page=minecraft-admin?site=filebrowser&path=' . $path . '&lochen=true">' . __("löschen", 'minecraft-admin') . '</a>';
    } //is_file($options["pfad"] . $path)
    else {
      $dir      = opendir($options["pfad"] . $path);
      $array    = array();
      $arrayneu = array();
      while ($file = readdir($dir)) {
        $filepath                     = $options["pfad"] . $path . "/" . $file;
        $stat                         = stat($filepath);
        $array[filetype($filepath)][] = array(
          'zugriff' => date("d-m-Y, H:i:s", $stat[8]),
          'anderung' => date("d-m-Y, H:i:s", $stat[9]),
          'size' => $this->binary_multiples($stat[7], true, false),
          'file' => $file
        );
      } //$file = readdir($dir)
      closedir($dir);
      foreach ($array as $id => $inhalt) {
        usort($inhalt, array(
          &$this,
          "cmp"
        ));
        $arrayneu[$id] = $inhalt;
      } //$array as $id => $inhalt
      echo "<table>";
      foreach ($arrayneu as $id => $inhalt) {
        foreach ($inhalt as $unterid => $unterinhalt) {
          if ($unterinhalt["file"] != "." and $unterinhalt["file"] != ".." and $unterinhalt["file"] != "aufgaben.crontab") {
            echo "<tr  class=\"mc_admin_hidden_false\"><td>[" . $id . "]</td><td><table class=\"mc_admin_hidden\"><tr><td>" . __("Lezter Zugriff", 'minecraft-admin') . ":</td><td> " . $unterinhalt["zugriff"] . "</td></tr><tr><td>" . __("Größe", 'minecraft-admin') . ":</td><td> " . $unterinhalt["size"] . "</td></tr><tr><td>" . __("Lezte Änderung", 'minecraft-admin') . ":</td><td> " . $unterinhalt["anderung"] . "</td></tr></table></td>";
            echo "<td><a href=\"admin.php?page=minecraft-admin?site=filebrowser&path=" . (($path == "/") ? "" : $path) . "/" . rawurlencode($unterinhalt["file"]) . "\">" . $unterinhalt["file"] . "</a></td><td><form style=\"margin:0;\" method=\"POST\" action=\"admin.php?page=minecraft-admin?site=filebrowser&path=" . (($path == "/") ? "" : $path) . "/" . rawurlencode($unterinhalt["file"]) . "\">Umbennen: <input type=\"text\" name=\"neu\" /></form></td><td><a href=\"admin.php?page=minecraft-admin?site=filebrowser&path=" . (($path == "/") ? "" : $path) . "/" . rawurlencode($unterinhalt["file"]) . "&lochen=true\">" . __("Löschen", 'minecraft-admin') . "</a></td></tr>";
          } //$unterinhalt["file"] != "." and $unterinhalt["file"] != ".." and $unterinhalt["file"] != "aufgaben.crontab"
        } //$inhalt as $unterid => $unterinhalt
      } //$arrayneu as $id => $inhalt
      echo '<tr><td>[NEU]</td><td></td><td><form action="" method="POST"><input name="neuerstellen" type="text" /><input type="submit" class="button-primary" value="' . __("erstellen", 'minecraft-admin') . '" /></form></td><td></td></tr></table><form enctype="multipart/form-data" action="" method="post">' . __("Wähle eine Datei, die hochgeladen werden soll", 'minecraft-admin') . ': <input name="datei" type="file"><input type="submit" value="' . __("Upload Datei", 'minecraft-admin') . '"></form>';
      if ($path != "/" XOR !empty($path) XOR $path != '') {
        echo '<a href="admin.php?page=minecraft-admin?site=filebrowser&path=' . $path . '&lochen=true">' . __("Aktuelles Verzeichnis löschen.", 'minecraft-admin') . '</a><form method="POST" action="">Neuer Name des Verzeichnisses: <input type="text" name="neu" /><input type="submit" class="button-primary" value="' . __("umbenennen", 'minecraft-admin') . '" /></form>';
      } //$path != "/" XOR !empty($path) XOR $path != ''
    }
  }
  function cmp($a, $b)
  {
    return strcmp($a["file"], $b["file"]);
  }
  function lochen_verzeichnis($path)
  {
    if (!is_dir($path)) {
      if (is_file($path)) {
        unlink($path);
      } //is_file($path)
      else {
        return -1;
      }
    } //!is_dir($path)
    $dir = @opendir($path);
    if (!$dir) {
      return -2;
    } //!$dir
    while (($entry = @readdir($dir)) !== false) {
      if ($entry == '.' || $entry == '..')
        continue;
      if (is_dir($path . '/' . $entry)) {
        $res = lochen_verzeichnis($path . '/' . $entry);
        if ($res == -1) {
          @closedir($dir);
          return -2;
        } //$res == -1
        else if ($res == -2) {
          @closedir($dir);
          return -2;
        } //$res == -2
        else if ($res == -3) {
          @closedir($dir);
          return -3;
        } //$res == -3
        else if ($res != 0) {
          @closedir($dir);
          return -2;
        } //$res != 0
      } //is_dir($path . '/' . $entry)
      else if (is_file($path . '/' . $entry) || is_link($path . '/' . $entry)) {
        $res = @unlink($path . '/' . $entry);
        if (!$res) {
          @closedir($dir);
          return -2;
        } //!$res
      } //is_file($path . '/' . $entry) || is_link($path . '/' . $entry)
      else {
        @closedir($dir);
        return -3;
      }
    } //($entry = @readdir($dir)) !== false
    @closedir($dir);
    $res = @rmdir($path);
    if (!$res) {
      return -2;
    } //!$res
    return 0;
  }
  function binary_multiples($size, $praefix = true, $short = true)
  {
    if ($praefix === true) {
      if ($short === true) {
        $norm = array(
          'B',
          'kB',
          'MB',
          'GB',
          'TB',
          'PB',
          'EB',
          'ZB',
          'YB'
        );
      } //$short === true
      else {
        $norm = array(
          'Byte',
          'Kilobyte',
          'Megabyte',
          'Gigabyte',
          'Terabyte',
          'Petabyte',
          'Exabyte',
          'Zettabyte',
          'Yottabyte'
        );
      }
      $factor = 1000;
    } //$praefix === true
    else {
      if ($short === true) {
        $norm = array(
          'B',
          'KiB',
          'MiB',
          'GiB',
          'TiB',
          'PiB',
          'EiB',
          'ZiB',
          'YiB'
        );
      } //$short === true
      else {
        $norm = array(
          'Byte',
          'Kibibyte',
          'Mebibyte',
          'Gibibyte',
          'Tebibyte',
          'Pebibyte',
          'Exbibyte',
          'Zebibyte',
          'Yobibyte'
        );
      }
      $factor = 1024;
    }
    $count = count($norm) - 1;
    $x     = 0;
    while ($size >= $factor && $x < $count) {
      $size /= $factor;
      $x++;
    } //$size >= $factor && $x < $count
    $size = sprintf("%01.2f", $size) . ' ' . $norm[$x];
    return $size;
  }
}
$my_minecraft_admin = new minecraft_admin();
?>