#!/bin/bash
# /etc/init.d/minecraft
# version 0.3.6 2011-10-17 (YYYY-MM-DD)

### BEGIN INIT INFO
# Provides:minecraft
# Required-Start: $local_fs $remote_fs
# Required-Stop:$local_fs $remote_fs
# Should-Start:$network
# Should-Stop: $network
# Default-Start:2 3 4 5
# Default-Stop:0 1 6
# Short-Description: Minecraft server
# Description: the start/stop file by minecraft admin for wordpress
### END INIT INFO

#Settings
#Diese Datei wurde automatisch generiert von MC Admin fuer Wordpress um 2012-10-14 16:09:36. Fuer mehr Informationen besuche http://minecraft.profenter.de
#This file was automatically generated by MC Admin for WordPress at 2012-10-14 16:09:36 . For more information visit http://minecraft.profenter.de
SERVICE='craftbukkit.jar'
OPTIONS='nogui'
USERNAME='www-data'
WORLDS='world,world_nether,show'
MCPATH='/opt/minecraft/'
BACKUPPATH='/opt/minecraft/backup'
CPU_COUNT=24
INVOCATION="java -Xmx1024M -Xms1024M -XX:+UseConcMarkSweepGC -XX:+CMSIncrementalPacing -XX:ParallelGCThreads=$CPU_COUNT -XX:+AggressiveOpts -jar $SERVICE $OPTIONS"

ME=`whoami`
as_user() {
if [ $ME = $USERNAME ] ; then
 bash -c "$1"
else
 su - $USERNAME -c "$1"
fi
}

mc_start() {
  if  pgrep -u $USERNAME -f $SERVICE > /dev/null
then
 echo "$SERVICE läuft bereits!"
else
 echo "Starte $SERVICE..."
 cd $MCPATH
 as_user "cd $MCPATH && screen -dmS minecraft $INVOCATION"
 sleep 7
 if pgrep -u $USERNAME -f $SERVICE > /dev/null
 then
echo "$SERVICE läuft nun."
 else
echo "Error! $SERVICE! konnte nicht gestartet werden"
 fi
fi
}

mc_saveoff() {
if pgrep -u $USERNAME -f $SERVICE > /dev/null
then
 echo "$SERVICE läuft... speichere die Karte"
 as_user "screen -p 0 -S minecraft -X eval 'stuff \"say SERVER BACKUP GESTARTET. Server geht in den lese Modus...\"\015'"
 as_user "screen -p 0 -S minecraft -X eval 'stuff \"save-off\"\015'"
 as_user "screen -p 0 -S minecraft -X eval 'stuff \"save-all\"\015'"
 sync
 sleep 10
else
 echo "$SERVICE läuft nicht. Nichts zum speichern."
fi
}

mc_saveon() {
if pgrep -u $USERNAME -f $SERVICE > /dev/null
then
 echo "$SERVICE läuft nun... Aktiviere die Karte"
 as_user "screen -p 0 -S minecraft -X eval 'stuff \"save-on\"\015'"
 as_user "screen -p 0 -S minecraft -X eval 'stuff \"say SERVER BACKUP ENDE. Server geht in den schreibe Modus...\"\015'"
else
 echo "$SERVICE läuft nicht. Nichts zum aktivieren."
fi
}

mc_stop() {
if pgrep -u $USERNAME -f $SERVICE > /dev/null
then
 echo "Stoppe $SERVICE"
 as_user "screen -p 0 -S minecraft -X eval 'stuff \"say Der Server wird in 10 Sekunden gestoppt. Die Map wird gespeichert...\"\015'"
 as_user "screen -p 0 -S minecraft -X eval 'stuff \"save-all\"\015'"
 sleep 10
 as_user "screen -p 0 -S minecraft -X eval 'stuff \"stop\"\015'"
 sleep 7
else
 echo "$SERVICE läuft nicht."
fi
if pgrep -u $USERNAME -f $SERVICE > /dev/null
then
 echo "Error! $SERVICE! konnte nicht gestartet werden"
else
 echo "$SERVICE ist gestoppt."
fi
}
mc_backup() {
echo "Lösche alte Datein..."
as_user "cd $BACKUPPATH && find $BACKUPPATH -ctime +14 -exec rm -rf {} \;"
echo "Sichere die Minecraft Welten..."
if [ -d $BACKUPPATH/${WORLD}_`date "+%Y.%m.%d_%H.%M"` ]
then
for i in 1 2 3 4 5 6
do
 if [ -d $BACKUPPATH/${WORLD}_`date "+%Y.%m.%d_%H.%M"`-$i ]
 then
continue
 else
as_user "cd $MCPATH && tar -czf $BACKUPPATH/_`date "+%Y.%m.%d_%H.%M"`-$i.tar.gz $WORLDS"
break
 fi
done
else
as_user "cd $MCPATH && tar -czf $BACKUPPATH/`date "+%Y.%m.%d_%H.%M"`.tar.gz $WORLDS"
echo "Welt gesichert"
fi
echo "Backup fertig"
}
mc_command() {
  command="$1";
  if pgrep -u $USERNAME -f $SERVICE > /dev/null
  then
    pre_log_len=`wc -l "$MCPATH/server.log" | awk '{print $1}'`
    as_user "screen -p 0 -S minecraft -X eval 'stuff \"$command\"\015'"
    sleep .1 # assumes that the command will run and print to the log file in less than .1 seconds
    # print output
    # tail -n $[`wc -l "$MCPATH/server.log" | awk '{print $1}'`-$pre_log_len] "$MCPATH/server.log"
    tail -n 1 "$MCPATH/server.log"
  fi
}

#Start-Stop here
case "$1" in
start)
 mc_start
 ;;
stop)
 mc_stop
 ;;
restart)
 mc_stop
 mc_start
 ;;
backup)
 mc_saveoff
 mc_backup
 mc_saveon
 ;;
status)
 if pgrep -u $USERNAME -f $SERVICE > /dev/null
 then
echo "$SERVICE läuft."
 else
echo "$SERVICE läuft nicht."
    fi
    ;;
  command)
    if [ $# -gt 1 ]; then
      shift
mc_command "$*"
 else
echo "Bitte gebe einen Kommando ein (versuche 'help' oder ?)"
 fi
 ;;

*)
echo "Benutze: $0 {start|stop|backup|status|restart|command \"server command\"}"
  exit 1
  ;;
esac

exit 0